% commands to reproduce Figure 4 of the paper 
% "Groebner Basis Methods for Multichannel Sampling with Unknown Offsets",
% Luciano Sbaiz, Patrick Vandewalle, and Martin Vetterli 

% Matlab and Mathematica code to reproduce results from the paper                  
% "Groebner Basis Methods for Multichannel Sampling with Unknown Offsets",
% Luciano Sbaiz, Patrick Vandewalle, and Martin Vetterli 
% available at http://lcavwww.epfl.ch/reproducible_research/SbaizVV06/ 
%                                                                           
% Copyright (C) 2006 Laboratory of Audiovisual Communications (LCAV),       
% Ecole Polytechnique Federale de Lausanne (EPFL),                          
% CH-1015 Lausanne, Switzerland                                             
%                                                                           
% This program is free software; you can redistribute it and/or modify it  
% under the terms of the GNU General Public License as published by the     
% Free Software Foundation; either version 2 of the License, or (at your    
% option) any later version. This software is distributed in the hope that  
% it will be useful, but without any warranty; without even the implied     
% warranty of merchantability or fitness for a particular purpose.          
% See the GNU General Public License for more details                       
% (enclosed in the file GPL).                                               
%                                                                           
% Latest modifications: June 13, 2006  

x = [5-j -3*j -6 3*j 5+j].';
xe = [4.7412-4.5812*j -0.0388-2.9566*j -5.9450 -0.0388+2.9566*j 4.7412+4.5812*j].';
% xe = [4.73391-4.95188*j -0.0433104-2.94113*j -5.89672 -0.0433104+2.94113*j 4.73391+4.95118*j].';
xe2 = [4.7412-5.7629*j -0.0457-2.9289*j -5.9065 -0.0457+2.9289*j 4.7412+5.7629*j].';
x_hr = zeros(101,1);
x_hr(49:53) = x;
xe_hr = zeros(101,1);
xe_hr(49:53) = xe;
xe2_hr = zeros(101,1);
xe2_hr(49:53) = xe2;
y0true = [4 -22 4 -10];
y1true = [3.02165 -7.5743 -0.359142 -19.0882];
y0 = [3.48449 -21.2468 3.66716 -9.53102];
y1 = [2.09168 -7.44795 0.729979 -19.3078];
figure; plot([0:1/101:1-1/101],101*real(ifft(ifftshift(x_hr))),'LineWidth',2)
hold on;
plot([0:0.25:0.75],y0,'ro','MarkerSize',7,'Linewidth',3);
plot(mod([0:0.25:0.75]+6/11,1),y1,'gx','MarkerSize',15,'Linewidth',3);
% plot([0:0.25:0.75],y0true,'ko','MarkerSize',7,'Linewidth',3);
% plot(mod([0:0.25:0.75]+5/7,1),y1true,'kx','MarkerSize',15,'Linewidth',3);
plot([0:1/101:1-1/101],101*real(ifft(ifftshift(xe_hr))),'g--','LineWidth',2)
plot([0:1/101:1-1/101],101*real(ifft(ifftshift(xe2_hr))),'r-.','LineWidth',2)
xlabel('t');
legend('f(t)','y_0(n)','y_1(n)','reconstruction Ex.5.1','reconstruction Ex.6.1','Location','Best');
